package core.api.models.timemanager.taskSchedule.scheduleInfos;

import com.fasterxml.jackson.annotation.JsonProperty;
import core.api.models.timemanager.taskgroup.TaskgroupEntityInfo;
import core.api.models.timemanager.tasks.TaskShortInfo;
import core.entities.timemanager.Task;

import java.time.LocalDateTime;
import java.util.List;

public abstract class ScheduleInfo {

    @JsonProperty
    private long scheduleID;
    @JsonProperty
    private ScheduleType scheduleType;
    @JsonProperty
    private LocalDateTime startTime;
    @JsonProperty
    private LocalDateTime finishedTime;
    @JsonProperty
    private int activeMinutes;
    @JsonProperty
    private TaskShortInfo task;
    @JsonProperty
    private List<TaskgroupEntityInfo> taskgroupPath;

    public ScheduleInfo(long scheduleID, ScheduleType scheduleType, LocalDateTime startTime, LocalDateTime stopTime, int activeMinutes, Task task, List<TaskgroupEntityInfo> taskgroupPath) {
        this.scheduleID = scheduleID;
        this.scheduleType = scheduleType;
        this.startTime = startTime;
        this.finishedTime = stopTime;
        this.activeMinutes = activeMinutes;
        this.task = new TaskShortInfo(task);
        this.taskgroupPath = taskgroupPath;
    }
}
