package core.entities.timemanager;

import javax.persistence.*;
import java.util.ArrayList;
import java.util.List;

@Entity
@Table(name = "task_series")
public class TaskSerie {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private long taskSerieID;

    @OneToMany(fetch = FetchType.EAGER, mappedBy = "taskSerie", orphanRemoval = true)
    List<TaskSerieItem> tasks = new ArrayList<>();




    public long getTaskSerieID() {
        return taskSerieID;
    }

    public void setTaskSerieID(long taskSerieID) {
        this.taskSerieID = taskSerieID;
    }

    public List<TaskSerieItem> getTasks() {
        return tasks;
    }

    public void setTasks(List<TaskSerieItem> tasks) {
        this.tasks = tasks;
    }

    public TaskSerieItem addTask(Task task) {
        TaskSerieItem taskSerieItem = new TaskSerieItem(this, task, this.tasks.size()+1);
        this.tasks.add(taskSerieItem);
        return taskSerieItem;
    }
}
