package core.repositories.timemanager;

import core.entities.timemanager.TaskSerie;
import core.entities.timemanager.Taskgroup;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import javax.transaction.Transactional;
import java.util.List;

@Repository
public interface TaskSeriesRepository extends CrudRepository<TaskSerie, Long> {
    @Query("SELECT DISTINCT ts FROM TaskSerie ts JOIN ts.tasks tsi JOIN tsi.task t WHERE t.taskgroup = :taskgroup")
    List<TaskSerie> findByTaskgroup(@Param("taskgroup")Taskgroup taskgroup);

    @Modifying
    @Transactional
    @Query(value = "DELETE FROM TaskSerie ts WHERE ts.tasks.size = 0")
    void deleteUnreferenced();
}
